{-# OPTIONS -fglasgow-exts #-}

-- Sample code for SXML in Haskell

module Main where

import HSXML
import HSXML_HTML
import Prelude hiding (head, tail, span, div)

test_haskell =
    (document
     (head
      [title "Haskell " longdash "XML Generator"]
      [meta_tag [description "This page is descript by" br "Haskell"]])
    (body
     [h1 "HSXML Test"]
     [date "2006ǯ0324" "yayoi222006"
      -- [p ""]
      [topic "HaskellSchemeXML"
             "HSXML ĩ - 2" "writing_in_hsxml_2"
       [p [[quoteWithLink "placeholder ȤƻȤɽʤ element νʬСġ" "HSXML ĩ - 1(?)" (FileURLA "" "writing_in_hsxml")]] "Ƚ񤤤ƤΤǤΤ"]
       [quoter [[program (unlines
           ["> newtype TSPAN a = TSPAN a deriving Show"
           ,"> tspan x = build (as_inline . HW . TSPAN . rev\'apppend HNil) nil_inline x"
           ,">  "
           ,"> instance RenderInline b => RenderInline (HW CT_inline (TSPAN b)) where"
           ,">     render_inline f (HW (TSPAN body)) = render_inline f body"])]]
        "http://www.haskell.org//pipermail/haskell/2006-March/017756.html"]
        [p "ȤñʤΤǤ"]
        [p "ʤǤʼʤ˵Ĥʤä" "¾Υ᥿ץߥƱ" [[linkWithTitle "饹᥿ץߥ" "De-typechecker; < d.v.d (05/03/09)" (URL "http://www.kmonos.net/wlog/48.php#_0113050309")]] "Υ顼åʬˤäȤϤΤ餤ʤ鵤ŤƤɤäΤˡġġ"]
        [p "ǽŪ TSPAN ϰʲ̤ꡣ"]
        [program (unlines
           ["> newtype TSPAN a = TSPAN a deriving Show"
           ,"> tspan x = build ((`as_ctx`  co) . HW . TSPAN  . rev'apppend HNil) nil_ab x"
           ,">     where nil_ab = HW HNil `as_ctx` ci"
           ,">	     (ci,co) = tspan_ctx"
           ,"> class Check_iab (Cite ()) i => TSPANCtx i o | i -> o, o -> i where "
           ,">     tspan_ctx :: (HW i a, HW o a) ; tspan_ctx = undefined"
           ,"> instance TSPANCtx CT_inline CT_inline"
           ,"> instance TSPANCtx CT_block CT_block"
           ,">"
           ,"> instance RenderInline b => RenderInline (HW CT_inline (TSPAN b)) where"
           ,">     render_inline f (HW (TSPAN body)) = render_inline f body"
           ,">"
           ,"> instance (Render b) => Render (HW CT_block (TSPAN b)) where"
           ,">    render (HW (TSPAN body)) = render body"])]
        [p " HSXML Ǽͳߤ񤱤ޤˡ block level  element ˤ⡢[[tspan [[something]] [[someting']]]] Ȥ褦˳ѳ̤ŤˤʤФʤʤΤǤ(Overlapping instances Ȥ褦ˤаŤɤȤä⤢ޤδĶǤϥʤ褦Ǥ)"]
      ]
      
      [topic "C++"
             "C++ Ǥ lambda Ƴ˴ؤ­" "lambda_and_return_type_in_cpp"
       [p "mixi Ǥ" [[linkWithTitle " C++ ƤƤ lambda" "C++0xɲͽ̵̾ؿ < ܤ" (URL "http://printf.jugem.jp/?eid=473")]] "äˤʤäΤ­Ƥޤ" [[linkWithTitle "decltype (typeof )" "Decltype and auto" (URL "http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2003/n1478.pdf")]] "äΤäƤΤʤ顢Ƥ줿ʸˡˤޤԻ׵Ĥ˴ϤʤȻפޤĤޤꡢ"]
       [quoter [[program "template <class T, class U> decltype(t+u) add(T t, U u);"]]
        "http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2003/n1478.pdf"]
       [p "ü첽Ȥ"]
       [quoter [[program "<> (int x, double y) -> decltype(x + y) {return x + y;}"]]
        "http://public.research.att.com/~bs/N1968-lambda-expressions.pdf"]
       [p "Ȥ˵ҤȤ褦ˤʤäƤ櫓Ǥʤߤ -> 귿򼨤ΥȤƻȤˡϤκˤϤ⤦Ƥꡢfun ɤؿη뤿ȤƻȤ"]
       [quoter [[program (unlines
           ["template <class T, class U> fun add(T t, U u) -> decltype(t + u);"
           ,"class A {"
           ,"  fun f() const -> int throw ();"
           ,"};"])]]
        "http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2003/n1478.pdf"]
       [p "Ƚ񤱤褦ˤ뤳ȤƤƤޤȤ櫓ǡ츫Լ˸ʸˡ⡢ C++ ɸˤĤƤ褯ΤäǤϤۤԻ׵ĤʤΤǤϤʤΤ⤷ޤ"]
       [p "(ġĤäѤ template ϴؿˤʤΤ)"]
      ]
      ]
     [hr]))


test_1C_r = as_doc test_haskell

-- The above example uses a few elements that were not introduced in
-- HSXML.hs. Therefore, we define them here. This is to highlight the
-- extensibility of the framework. New `tags' can be defined at any time.

-- An abbreviation for the long dash. It may appear in the character
-- content of an element or an attribute
data LongDash = LongDash deriving Show
longdash :: Check_ia LongDash ct => HW ct LongDash
longdash = HW LongDash

-- and how to render it in HTML
instance RenderInline (HW ct LongDash) where
    render_inline f _ = emit_lit "&mdash;" >> return f


-- Anchor is an inline element with an inline content
data Anchor a b = Anchor a b deriving Show
a attrs body = 
  build (as_inline . HW . Anchor (as_block attrs) . rev'apppend HNil) 
	nil_inline body

-- As an additional check, the renderer makes sure that the Anchor 
-- indeed appears in the Inline context. This is a _static_ check.
instance (Render a, RenderInline b) => 
    RenderInline (HW CT_inline (Anchor a b)) where
    render_inline f (HW (Anchor attrs body)) =
	add_space f >>
	emit_elem "a" [] (Just (render attrs)) (render_ib body)
	>> return True

-- The body of Div has the content Block, and the Div element itself
-- is in the Block context
data DIV a b = DIV a b deriving Show

div attrs body = 
    buildG (as_block . HW . da . rev'apppend HNil) nil_block body
	where da = DIV (as_block attrs)

instance (Render a, Render b) => Render (HW CT_block (DIV a b)) where
    render (HW (DIV attrs body)) = 
	emit_elem "div" [Hint_nl] (Just (render attrs)) (Just (render body))


-- Title can be either 
--    - a block-level element whose content is CT_inline
--    - an attribute (whose content is, therefore, CT_attr)
newtype Title a = Title a deriving Show
title x = build ((`as_ctx`  co) . HW . Title . rev'apppend HNil) nil_ab x
    where nil_ab = HW HNil `as_ctx` ci
	  (ci,co) = title_ctx
class Check_ia (Title ()) i => TitleCtx i o | i -> o, o -> i where 
    title_ctx :: (HW i a, HW o a) ; title_ctx = undefined
instance TitleCtx CT_attr CT_battr
instance TitleCtx CT_inline CT_block


instance RenderInline a => Render (HW CT_battr (Title a)) where
    render (HW (Title x)) = emit_attr "title" 
			    ((render_inline False x) >> return ())

instance RenderInline a => Render (HW CT_block (Title a)) where
    render (HW (Title x)) = emit_elem "title" [Hint_nl] Nothing
			    (render_ib x)


data HR = HR deriving Show
hr :: Check_iab HR ct => HW ct HR
hr = HW HR

instance Render (HW CT_block HR) where
    render (HW HR) = emit_lit "\n<hr />\n"


data Pre a b = Pre a b deriving Show
pre attrs body =
  build (as_block . HW . Pre (as_block attrs) . rev'apppend HNil)
        nil_inline body

instance (Render a, RenderInline b) =>Render (HW CT_block (Pre a b)) where
    render (HW (Pre attrs body)) =
       emit_elem "pre" [] (Just (render attrs)) (render_ib body)


data PWithAttr a b = PWithAttr a b deriving Show
pWithAttr attrs body =
  build (as_block . HW . PWithAttr (as_block attrs) . rev'apppend HNil)
        nil_inline body

instance (Render a, RenderInline b) =>Render (HW CT_block (PWithAttr a b)) where
    render (HW (PWithAttr attrs body)) =
       emit_elem "p" [] (Just (render attrs)) (render_ib body)


data Quote a b = Quote a b deriving Show
quote attrs body = build ((`as_ctx`  co) . HW . Quote (as_block attrs)  . rev'apppend HNil) nil_ab body
    where nil_ab = HW HNil `as_ctx` ci
	  (ci,co) = quote_ctx
class Check_iab (Quote () ()) i => QuoteCtx i o | i -> o, o -> i where 
    quote_ctx :: (HW i a, HW o a) ; quote_ctx = undefined
instance QuoteCtx CT_inline CT_inline
instance QuoteCtx CT_block CT_block

instance (Render a, RenderInline b) =>RenderInline (HW CT_inline (Quote a b)) where
    render_inline f (HW (Quote attrs body)) =
       emit_elem "q" [] (Just (render attrs)) (render_ib body)
       >> return False

instance (Render a, Render b) => Render (HW CT_block (Quote a b)) where
    render (HW (Quote attrs body)) = 
	emit_elem "blockquote" [Hint_nl] (Just (render attrs)) (Just (render body))


newtype Class a = Class a deriving Show
klass x = build (as_battr . HW . Class . rev'apppend HNil) nil_inline x

instance RenderInline a => Render (HW CT_battr (Class a)) where
    render (HW (Class x)) = emit_attr "class" 
			    ((render_inline False x) >> return ())


newtype Id a = Id a deriving Show
idAttr x = build (as_battr . HW . Id . rev'apppend HNil) nil_inline x

instance RenderInline a => Render (HW CT_battr (Id a)) where
    render (HW (Id x)) = emit_attr "id" 
			    ((render_inline False x) >> return ())


newtype Cite a = Cite a deriving Show
cite x = build ((`as_ctx`  co) . HW . Cite . rev'apppend HNil) nil_ab x
    where nil_ab = HW HNil `as_ctx` ci
	  (ci,co) = cite_ctx
class Check_ia (Cite ()) i => CiteCtx i o | i -> o, o -> i where 
    cite_ctx :: (HW i a, HW o a) ; cite_ctx = undefined
instance CiteCtx CT_attr CT_battr
instance CiteCtx CT_inline CT_inline


instance RenderInline a => Render (HW CT_battr (Cite a)) where
    render (HW (Cite x)) = emit_attr "cite" 
			    ((render_inline False x) >> return ())

instance (RenderInline a) =>RenderInline (HW CT_inline (Cite a)) where
    render_inline f (HW (Cite body)) =
       emit_elem "cite" [] Nothing (render_ib body)
       >> return False


newtype Src = Src URL deriving Show
src = HW . Src

instance Render (HW CT_battr Src) where
    render (HW (Src url)) = emit_attr "src" (emit_url url)


newtype Alt a = Alt a deriving Show
alt x = build (as_battr . HW . Alt . rev'apppend HNil) nil_inline x

instance RenderInline a => Render (HW CT_battr (Alt a)) where
    render (HW (Alt x)) = emit_attr "alt" 
			    ((render_inline False x) >> return ())


data Image a b = Image a b deriving Show
image attrs =
  build (as_inline . HW . Image (as_block attrs) . rev'apppend HNil)
        nil_inline ""

instance (Render a, RenderInline b) =>RenderInline (HW CT_inline (Image a b)) where
    render_inline f (HW (Image attrs body)) =
       emit_elem "img" [] (Just (render attrs)) (render_ib body)
       >> return False

{-
newtype Image a = Image a deriving Show
image x = buildG (as_block . HW . Image . rev'apppend HNil) nil_inline x

instance Render a => Render (HW CT_block (Image a)) where
    render (HW (Image attrs))
	= emit_elem "img" [Hint_nl] (Just (render attrs)) Nothing
-}


data Abbr a b = Abbr a b deriving Show
abbr attrs =
  build (as_inline . HW . Abbr (as_block attrs) . rev'apppend HNil)
        nil_inline ""

instance (Render a, RenderInline b) =>RenderInline (HW CT_inline (Abbr a b)) where
    render_inline f (HW (Abbr attrs body)) =
       emit_elem "abbr" [] (Just (render attrs)) (render_ib body)
       >> return False


newtype Ruby a = Ruby a deriving Show
ruby x = build (as_inline . HW . Ruby . rev'apppend HNil) nil_inline x

instance RenderInline a => RenderInline (HW CT_inline (Ruby a)) where
    render_inline f (HW (Ruby m)) = 
	add_space f >>
	emit_elem "ruby" [] Nothing (render_ib m) >> return True


newtype Rb a = Rb a deriving Show
rb x = build (as_inline . HW . Rb . rev'apppend HNil) nil_inline x

instance RenderInline a => RenderInline (HW CT_inline (Rb a)) where
    render_inline f (HW (Rb m)) = 
	emit_elem "rb" [] Nothing (render_ib m) >> return True

newtype Rt a = Rt a deriving Show
rt x = build (as_inline . HW . Rt . rev'apppend HNil) nil_inline x

instance RenderInline a => RenderInline (HW CT_inline (Rt a)) where
    render_inline f (HW (Rt m)) = 
	emit_elem "rt" [] Nothing (render_ib m) >> return True

newtype Rp a = Rp a deriving Show
rp x = build (as_inline . HW . Rp . rev'apppend HNil) nil_inline x

instance RenderInline a => RenderInline (HW CT_inline (Rp a)) where
    render_inline f (HW (Rp m)) = 
	emit_elem "rp" [] Nothing (render_ib m) >> return True


data Span a b = Span a b deriving Show
span attrs body =
  build (as_inline . HW . Span (as_block attrs) . rev'apppend HNil)
        nil_inline body

instance (Render a, RenderInline b) =>RenderInline (HW CT_inline (Span a b)) where
    render_inline f (HW (Span attrs body)) =
       emit_elem "span" [] (Just (render attrs)) (render_ib body)
       >> return False


h3 x = build (as_block . HW . HTag 3 . rev'apppend HNil) nil_inline x
h4 x = build (as_block . HW . HTag 4 . rev'apppend HNil) nil_inline x
h5 x = build (as_block . HW . HTag 5 . rev'apppend HNil) nil_inline x


newtype TSPAN a = TSPAN a deriving Show
-- tspan x = build (as_inline . HW . TSPAN . rev'apppend HNil) nil_inline x
tspan x = build ((`as_ctx`  co) . HW . TSPAN  . rev'apppend HNil) nil_ab x
    where nil_ab = HW HNil `as_ctx` ci
	  (ci,co) = tspan_ctx
class Check_iab (Cite ()) i => TSPANCtx i o | i -> o, o -> i where 
    tspan_ctx :: (HW i a, HW o a) ; tspan_ctx = undefined
instance TSPANCtx CT_inline CT_inline
instance TSPANCtx CT_block CT_block

instance RenderInline b => RenderInline (HW CT_inline (TSPAN b)) where
    render_inline f (HW (TSPAN body)) = render_inline f body

instance (Render b) => Render (HW CT_block (TSPAN b)) where
    render (HW (TSPAN body)) = render body


link keyword url = a (attr [href url]) keyword
linkWithTitle keyword text url = a (attr [href url] [title text]) keyword

linkToAmazon keyword asin = link keyword (URL $ concat ["http://www.amazon.co.jp/exec/obidos/ASIN/", asin, "/shelarcy-22/"])


book title urn = cite [[link title (URL $ concat ["urn:isbn:", urn])]] "(" [[linkToAmazon "Amazon" urn]] ")"
bookWithSite title urn supportURI = bookWithDescription title urn "Υ" supportURI
bookWithSupportSite title urn supportURI = bookWithDescription title urn "Υݡȥ" supportURI

bookWithDescription title urn descript supportURI = cite [[book title urn]] "(" [[link [[tspan title  descript]] supportURI]] ")"

program programCode = pre (attr [klass "program"]) [[code programCode]]

quoter text uri = quote (attr [cite uri]) text
quoteByTitle text name = quote (attr [title name]) text
quoteWithTitle text name uri = quote (attr [title name] [cite uri]) text
quoteWithLink text name = link [[quoteByTitle text name]]

quoteImage imageFileURI contentDescription uri = quoter [[image (attr [src imageFileURI] [alt contentDescription])]] uri
quoteImageByTitle imageFileURI contentDescription = quoteByTitle [[image (attr [src imageFileURI] [alt contentDescription])]] contentDescription
quoteImageWithLink imageFileURI contentDescription uri = link [[quoteImage imageFileURI contentDescription uri]] uri

-- abbreviation text fulltext = abbr (attr [title fulltext]) text
abbrs text fullText = abbr (attr [title fullText]) text
rubys text rubyText = ruby [[rb text]] [[rp "("]] [[rt rubyText]] [[rp ")"]]

interface body = span (attr [klass "interface"]) body

section name body = div (attr [klass "section"] [idAttr name]) body

footnote body = specialSection "footnote" body
reference body = specialSection "reference" body
flavor body = specialSection "flavor" body
dialog body = specialSection "body" body
tail body   = specialSection "tail" body
seen body   = specialSection "seen" body

specialSection name = div (attr [klass name])

date writeDate name body = section name [h3 [[link writeDate (FileURLA "" name)]]] body
topic category title name body =  section name [h4 [[link title (FileURLA "" name)]]]
                                               [pWithAttr (attr [klass "topic"]) (concat ["[topic:", category, "]"])] body
subtopic title name body = section name [h5 [[link title (FileURLA "" name)]]] body

main :: IO () = runHTMLRender $ render test_haskell
